package cs61b.lec3;

public class ArrayExamples {
	public static void main(String[] args){
		//ArraySimpleExample();
		//ArrayCopyExample();
		//ArrayCopyExample2();
		//CommandLineExample(args);
		TriangularArray(6);
		//test();
	}
	
	public static void ArraySimpleExample(){
		int[] a = new int[100];
		for (int i = 0; i < 100; i++){
			a[i] = i;
		}
		for (int i = 0; i < 100; i++) {
			System.out.println(" " + a[i]);
		}
		
	}
	
	public static void ArrayCopyExample(){
		int[] smallPrimes = { 2, 3, 5, 7, 11, 13};
		for (int i = 0; i < smallPrimes.length; i++) {
			System.out.print(smallPrimes[i] + " ");
		}
		System.out.println();

		int[] luckyNumber = smallPrimes;
		luckyNumber[5] = 12;
		for (int i = 0; i < smallPrimes.length; i++) {
			System.out.print(smallPrimes[i] + " ");
		}	
	}
	
	public static void ArrayCopyExample2(){
		int[] smallPrimes = { 2, 3, 5, 7, 11, 13};
		int[] luckyNumbers = {101, 102, 103, 104, 105, 106,107};
		System.arraycopy(smallPrimes, 2, luckyNumbers, 3, 4);
		for (int i = 0; i < luckyNumbers.length; i++) {
			System.out.println(i + ":" + luckyNumbers[i]);
		}
	}
	
	public static void CommandLineExample(String[] args) {
		if (args[0].equals("-h")){
			System.out.print("Hello,");
		} else if (args[0].equals("-g")){
			System.out.print("Goodbye,");
		}
		
		for (int i = 1; i < args.length; i++) {
			System.out.print(" " + args[i]);
		}
		System.out.println("!");
	}
	
	public static void TriangularArray(int n) {
		int[][]pascal = new int[n][];
		for (int i = 0; i < n; i++) {
			pascal[i] = new int[i+1]; //construct row i
			pascal[i][0] = 1; //leftmost value of row i
			for (int j = 1; j < i; j++) {
				pascal[i][j] = pascal[i-1][j-1] + pascal[i-1][j];
			}
			pascal[i][i] = 1; //right most row. 				                                              
		}
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j <= i; j++) {
				System.out.print(" " + pascal[i][j]);	
			}
			System.out.println();
		}
	}
	
	public static void test() {
		for (int i = 0; i < 100; i++) {
			for (int j = 0; j < 100; j++) {
				if (j > 10) 
					break;
			}
			System.out.println("Here");
			return;
		}
	}
}
